-- Warborg is Wargames playing on network
-- Copyright (C) 2011 Manuel De Girardi

-- This Program is Free Software: You Can Redistribute It and/or Modify
-- It Under The Terms of The GNU General Public License As Published By
-- The Free Software Foundation, Either Version 3 of The License, or
-- (at Your Option) Any Later Version.

-- This Program is Distributed in The Hope That It Will Be Useful,
-- But WITHOUT ANY WARRANTY; Without Even The Implied Warranty of
-- MERCHANTABILITY or FITNESS for A PARTICULAR PURPOSE.  See The
-- GNU General Public License for More Details.

-- You Should Have Received A Copy of The GNU General Public License
-- Along with This Program.  if not, See <Http://Www.Gnu.Org/Licenses/>.
with Ada.Text_Io;
use Ada;
with Ada.Float_Text_Io;
with Ada.Strings.Fixed;
use Ada.Strings;
with Warborg.Nation.Manager;
use Warborg.Nation;

package body Warborg.Database is
   
   Charge_Factor : constant Float := 50.0;
   
   
   function "<" (Left, Right : in Missile_Type) return Boolean is
   begin
      return (Left.Missile_Attributes.Source.X < Right.Missile_Attributes.Source.X) and (Left.Missile_Attributes.Source.Y < right.Missile_Attributes.Source.Y);
   end "<";
   
   use Weapon.Manager;
   package Sorting_Vector is new Weapon.Manager.Generic_Sorting("<");
   
   All_Populations : nation.Manager.Vector;
   
   
   
   
   function Is_In(Target, Item : in Map_Coordonates_Type; Factor : in Float) return Boolean is
   begin
      if ((Item.X - (Target.X - Factor)) >= 0.0 and
	    (Item.X - (Target.X + Factor)) <= 0.0) and
	((Item.Y - (Target.Y - Factor)) >= 0.0 and
	   (Item.Y - (Target.Y + Factor)) <= 0.0) then

	 return True;
      else
	 return False;
      end if;
   end Is_In;
	 
   
   
   
   
   
   
   
   
   
   
   
   protected body Sgbd_Type is


      entry Get_Wopr(Logname : in String;
                     Wopr : out Joshua_Type;
                     Success : out boolean) when Allway is
      begin
         Wopr_List.Current := Wopr_List.Root;
         Success := False;
         while Wopr_List.Current /= null loop
            if Wopr_List.Current.Player_Name.all = Logname then
               Wopr := Wopr_List.Current.Wopr;
               Success := True;
               exit;
            end if;
            Wopr_List.Current := Wopr_List.Current.Next;
         end loop;
      end Get_Wopr;

      entry Add_Wopr(Logname : in String;
                     Wopr : in Joshua_Type;
                     Success : out boolean) when Allway is
      begin
         Success := False;	 
         declare
            New_Element : Node_Access := new Node_Type ' (new String ' (Logname),
                                                          Wopr,
                                                          null); --,
	    
         begin
	    New_Element.Wopr.Populations := All_Populations;
            if Wopr_List.Root /= null then

               Wopr_List.Current := Wopr_List.Root;
               while Wopr_List.Current.Next /= null loop

                  Wopr_List.Current :=  Wopr_List.Current.Next;
               end loop;

               Wopr_List.Current.next := New_Element;
            else
               Wopr_List.Root := New_Element;
               Wopr_List.Current := Wopr_List.Root;


            end if;
         end;
         Wopr_List.Nbr := Wopr_List.Nbr + 1;
         Success := True;
      end Add_Wopr;

      
      entry Get_Enemy(Logname : in String;
                      Missiles : out Weapon.Manager.Vector) when Allway is
	 
	 
	 Temp : Weapon.Manager.Vector;
	   
      begin

         Wopr_List.Current := Wopr_List.Root;
         while Wopr_List.Current /= null  Loop
	    
            if Wopr_List.Current.Player_Name.all /= Logname then
	       
               temp := temp & Wopr_List.Current.Wopr.Weapons;

            end if;

            Wopr_List.Current := Wopr_List.Current.Next;
         end loop;
	 
	 Sorting_Vector.Sort(temp);
	 if not Is_Empty(Temp) then
	    for I in 1..Weapon.Manager.Extended_Index'Min(40000, Last_Index(Temp)) loop
	       Missiles := Missiles & Element(Temp, I);
	    end loop;
	 end if;
	 
	 
	 
	 
      end Get_Enemy;

      entry Add_Missile(Logname : in String;
                        Missile : in Missile_Type;
                        Success : out Boolean) when Allway is
      begin
         Success := False;


         Wopr_List.Current := Wopr_List.Root;
         if Wopr_List.Current.Player_Name.all = Logname then
	    
            Weapon.Manager.Insert(Wopr_List.Current.Wopr.Weapons,
                                    Weapon.Manager.Last_index(Wopr_List.Current.Wopr.Weapons) + 1, Missile, 1);
            Success := True;
         else
            while Wopr_List.Current.Next /= null loop
               Wopr_List.Current := Wopr_List.Current.Next;
               if Wopr_List.Current.Player_Name.all = Logname then
		  
                  Weapon.Manager.Insert(Wopr_List.Current.Wopr.Weapons,
                                          Weapon.Manager.Last_index(Wopr_List.Current.Wopr.Weapons) + 1, Missile, 1);
                  Success := True;

                  exit;
               end if;

            end loop;
         end if;
      end Add_Missile;

      entry Launch_One(Logname : in String;
                       Missile_Id : in Missile_Vector_Index_type) when Allway is


      begin
         Loose := False;
         Back := 0;
         Wopr_List.Current := Wopr_List.Root;

	 
         while Wopr_List.Current /= null loop
            if Wopr_List.Current.Player_Name.all = Logname then

               if not Weapon.Manager.Is_Empty(Wopr_List.Current.Wopr.Weapons) then


                  Launched_Missile_Attributes :=
                    Weapon.Manager.Element(Wopr_List.Current.Wopr.Weapons, Missile_Id).Missile_attributes;
		  Launched_Missile_Attributes.Cible := To_Map_Coordonates(Launched_Missile_Attributes.Target);
		  
		  

                  Weapon.Manager.Delete(Wopr_List.Current.Wopr.Weapons, Missile_Id, 1);



                  Temp := Wopr_List.Root;
                  while Temp /= null loop		     
		     if not Weapon.Manager.Is_Empty(Temp.Wopr.Weapons) then
			
                        for L in 1..Weapon.Manager.Last_Index(Temp.Wopr.Weapons) loop
                           Missile_Attributes :=
                             Weapon.Manager.Element(temp.Wopr.Weapons,
						    Missile_Vector_Index_Type(Natural(L) -
										Back)).Missile_attributes;
			   
                           if (Missile_Attributes.Source.X >=
                                 Launched_Missile_Attributes.Cible.X -
                                 Launched_Missile_Attributes.Charge * Charge_Factor and
                                 Missile_Attributes.Source.X <=
                                 Launched_Missile_Attributes.Cible.X +
                                 Launched_Missile_Attributes.Charge * Charge_Factor) and
                             (Missile_Attributes.Source.Y >=
                                Launched_Missile_Attributes.Cible.Y -
                                Launched_Missile_Attributes.Charge * Charge_Factor and
                                Missile_Attributes.Source.Y <=
                                Launched_Missile_Attributes.Cible.Y +
                                Launched_Missile_Attributes.Charge * Charge_Factor) then
                              if not Loose then
                                 Loose := True;
                              end if;
                              Weapon.Manager.delete(Temp.Wopr.Weapons,
						    Missile_Vector_Index_Type(Natural(L) - Back), 1);
			      
			      Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Missiles := Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Missiles + 1;
                              Back := Back + 1;
                           end if;
			   

                        end loop;
                        Back := 0;

		       end if;

		       Wopr_Attributes := Temp.Wopr.Wopr_Attributes;

		       if (Wopr_Attributes.Source.X >=
			     Launched_Missile_Attributes.Cible.X -
			     Launched_Missile_Attributes.Charge * Charge_Factor and
			     Wopr_Attributes.Source.X <=
			     Launched_Missile_Attributes.Cible.X +
			     Launched_Missile_Attributes.Charge * Charge_Factor) and
			 (Wopr_Attributes.Source.Y >=
			    Launched_Missile_Attributes.Cible.Y -
			    Launched_Missile_Attributes.Charge * Charge_Factor and
			    Wopr_Attributes.Source.Y <=
			    Launched_Missile_Attributes.Cible.Y +
			    Launched_Missile_Attributes.Charge * Charge_Factor) then

			  Loose := False;
			  

			  Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Wopr :=
			    Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Wopr + 1;
			  Wopr_List.Current.Wopr.Wopr_Attributes.Earned_Missiles :=
			    Wopr_List.Current.Wopr.Wopr_Attributes.Earned_Missiles +
			    Natural(Last_Index(Temp.Wopr.Weapons));

			  if not Weapon.Manager.Is_Empty(Temp.Wopr.Weapons) Then
			     Local := local & Temp.Wopr.Weapons;
			     Weapon.Manager.Clear(Temp.Wopr.Weapons);
			  end if;

			  if Temp = Wopr_List.Root then

			     if Wopr_List.Root.Next /= null then

				Wopr_List.Root := Wopr_List.Root.Next;
				Temp := Wopr_List.root;
			     else

				Wopr_List.Root := null;
				Temp := null;
				Wopr_List.Current := null;
			     end if;

			  else

			     Prev.next := Temp.Next;
			     Temp := Prev.Next;
			  end if;
			  Wopr_List.Nbr := Wopr_List.Nbr - 1;




		       else

			  Prev := Temp;
			  Temp := Temp.Next;

		       end if;

		       if Loose then
			  Loose := False;
		       end if;
		  
		  end loop;


                  if Wopr_List.Current /= null then
                     Clear(Wopr_List.Current.Wopr.Weapons);
                     Wopr_List.Current.Wopr.Weapons :=
                       Wopr_List.Current.Wopr.Weapons & Local;
                  end if;

	    end if;

               exit;
            end if;
            Wopr_List.Current := Wopr_List.Current.Next;
         end loop;
      end Launch_One;

      entry Launch_All(Logname : in String) when Allway is


      begin
         Wopr_List.Current := Wopr_List.Root;



         while Wopr_List.Current /= null loop
            if Wopr_List.Current.Player_Name.all = Logname then
               if not Weapon.Manager.Is_Empty(Wopr_List.Current.Wopr.Weapons) then

              Main :
                  while Weapon.Manager.Last_Index(Wopr_List.Current.Wopr.Weapons) /= 0 loop
                     Launched_Missile_Attributes :=
                       Element(Wopr_List.Current.Wopr.Weapons, 1).Missile_attributes;
                     delete(Wopr_List.Current.Wopr.Weapons, 1, 1);
		     
		     Launched_Missile_Attributes.Cible := To_Map_Coordonates(Launched_Missile_Attributes.Target);
		     
		     Text_Io.Put_line("Last index " & Integer'Image(Weapon.Manager.Last_Index(Wopr_List.Current.Wopr.Weapons)));

		     
		     declare
			Populations : Nation.Manager.Vector;			
		     begin
			for I in 1..Nation.Manager.Last_Index(Wopr_List.Current.Wopr.Populations) loop			   
			   Populations := Populations & Nation.Manager.Element(Wopr_List.Current.Wopr.Populations, I);
			end loop;
			Nation.Manager.Clear(Wopr_List.Current.Wopr.Populations);
			for I in 1..Nation.Manager.Last_Index(Populations) loop
			   declare
			      Gps_Coordonates : Gps_Coordonates_Type := Nation.Manager.Element(Populations, i).Gps_Coordonates;
			      Map_Coordonates : Map_Coordonates_Type := To_Map_Coordonates(GPS_Coordonates);
			   begin
			      if Is_In(Launched_Missile_Attributes.Cible, Map_Coordonates, Launched_Missile_Attributes.Charge * Charge_Factor) then
				 --  if (Map_Coordonates.X >=
				 --        Launched_Missile_Attributes.Cible.X -
				 --     Launched_Missile_Attributes.Charge * Charge_Factor and
				 --     Map_Coordonates.X <=
				 --        Launched_Missile_Attributes.Cible.X +
				 --        Launched_Missile_Attributes.Charge * Charge_Factor) and
				 --    (Map_Coordonates.Y >=
				 --       Launched_Missile_Attributes.Cible.Y -
				 --       Launched_Missile_Attributes.Charge * Charge_Factor and
				 --       Map_Coordonates.Y <=
				 --       Launched_Missile_Attributes.Cible.Y +
				 --       Launched_Missile_Attributes.Charge * Charge_Factor) then
				 --  null;
				 Text_Io.Put("Personal Population destroyed");
				 --Delete(populations, I, 1);			      
			      else
				 Wopr_List.Current.Wopr.Populations := Wopr_List.Current.Wopr.Populations & Nation.Manager.Element(Populations, i);
			      end if;
				
			   end;
			end loop;									
		     end;
		     
		     --Text_Io.Put_line("Population 2");
		     
		     
		     
		     
		     
		     
		     
		     
		     
                     Temp := Wopr_List.root;
                     while Temp /= null loop
			if Temp.Player_Name.all /= Logname then
			   --Text_Io.Put_line("Population 3");
			   declare
			      Populations : Nation.Manager.Vector;
			   begin
			      for I in 1..Nation.Manager.Last_Index(Temp.Wopr.Populations) loop			   
				 Populations := Populations & Nation.Manager.Element(Temp.Wopr.Populations, I);
			      end loop;
			      Nation.Manager.Clear(temp.Wopr.Populations);
			      for I in 1..Nation.Manager.Last_Index(Populations) loop
				 declare
				    Gps_Coordonates : Gps_Coordonates_Type := Nation.Manager.Element(Populations, i).Gps_Coordonates;
				    Map_Coordonates : Map_Coordonates_Type := To_Map_Coordonates(GPS_Coordonates);
				 begin
				    if Is_In(Launched_Missile_Attributes.Cible, Map_Coordonates, Launched_Missile_Attributes.Charge * Charge_Factor) then
				    --  if (Map_Coordonates.X >=
				    --  	  Launched_Missile_Attributes.Cible.X -
				    --  	  Launched_Missile_Attributes.Charge * Charge_Factor and
				    --  	  Map_Coordonates.X <=
				    --  	  Launched_Missile_Attributes.Cible.X +
				    --  	  Launched_Missile_Attributes.Charge * Charge_Factor) and
				    --    (Map_Coordonates.Y >=
				    --  	 Launched_Missile_Attributes.Cible.Y -
				    --  	 Launched_Missile_Attributes.Charge * Charge_Factor and
				    --  	 Map_Coordonates.Y <=
				    --  	 Launched_Missile_Attributes.Cible.Y +
				    --  	 Launched_Missile_Attributes.Charge * Charge_Factor) then
				    --     null;
				       Text_Io.Put("Others Population destroyed");
				       --Print(PGS_Coordonates);
				       
				       --Delete(Populations, I, 1);
				    else
				       temp.Wopr.Populations :=  temp.Wopr.Populations & Nation.Manager.Element(Populations, i);
				    end if;				    
				 end;				 
			      end loop;	
			      
			      
			   end;
			   
			   
			   
			   if not Is_Empty(Temp.Wopr.Weapons) then			      			      			      			      			      			      			      			      			      
			      for L in 1..Last_Index(Temp.Wopr.Weapons) loop
				 Missile_Attributes :=
				   Element(temp.Wopr.Weapons,
					   Missile_Vector_Index_Type(Natural(L) - Back)).Missile_attributes;
				 Missile_Attributes.Source := To_Map_Coordonates(Missile_Attributes.Position);
				 if Is_In(Launched_Missile_Attributes.Cible, Missile_Attributes.Source, Launched_Missile_Attributes.Charge * Charge_Factor) then
				 --  if (Missile_Attributes.Source.X >=
				 --        Launched_Missile_Attributes.Cible.X -
				 --        Launched_Missile_Attributes.Charge * Charge_Factor and
				 --        Missile_Attributes.Source.X <=
				 --        Launched_Missile_Attributes.Cible.X +
				 --        Launched_Missile_Attributes.Charge * Charge_Factor) and
				 --    (Missile_Attributes.Source.Y >=
				 --       Launched_Missile_Attributes.Cible.Y -
				 --       Launched_Missile_Attributes.Charge * Charge_Factor and
				 --       Missile_Attributes.Source.Y <=
				 --       Launched_Missile_Attributes.Cible.Y +
				 --       Launched_Missile_Attributes.Charge * Charge_Factor) then
				    if not Loose then
				       Loose := True;
				    end if;
				    delete(Temp.Wopr.Weapons,
					   Missile_Vector_Index_Type(Natural(L) - Back), 1);
				    Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Missiles := Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Missiles + 1;
				    Back := Back + 1;
				 end if;
				 
			      end loop;
			      Back := 0;

			   end if;

			   Wopr_Attributes := Temp.Wopr.Wopr_Attributes;
			   Wopr_Attributes.Source := To_Map_Coordonates(Wopr_Attributes.GPS_Coordonate);
			   if Is_In(Launched_Missile_Attributes.Cible, Wopr_Attributes.Source, Launched_Missile_Attributes.Charge * Charge_Factor) then
			      --  if (Wopr_Attributes.Source.X >=
			     --  	 Launched_Missile_Attributes.Cible.X -
			     --  	 Launched_Missile_Attributes.Charge * Charge_Factor and
			     --  	 Wopr_Attributes.Source.X <=
			     --  	 Launched_Missile_Attributes.Cible.X +
			     --  	 Launched_Missile_Attributes.Charge * Charge_Factor) and
			     --  (Wopr_Attributes.Source.Y >=
			     --  	Launched_Missile_Attributes.Cible.Y -
			     --  	Launched_Missile_Attributes.Charge * Charge_Factor and
			     --  	Wopr_Attributes.Source.Y <=
			     --  	Launched_Missile_Attributes.Cible.Y +
			     --  	Launched_Missile_Attributes.Charge * Charge_Factor) then




			      Loose := False;

			      Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Wopr :=
				Wopr_List.Current.Wopr.Wopr_Attributes.Destroyed_Wopr + 1;
			      Wopr_List.Current.Wopr.Wopr_Attributes.Earned_Missiles :=
				Wopr_List.Current.Wopr.Wopr_Attributes.Earned_Missiles +
				Natural(Last_Index(Local));
			      if not Is_Empty(Temp.Wopr.Weapons) Then
				 Local := local & Temp.Wopr.Weapons;
				 Clear(Temp.Wopr.Weapons);
			      end if;

			      if Temp = Wopr_List.Root then

				 if Wopr_List.Root.Next /= null then

				    Wopr_List.Root := Wopr_List.Root.Next;
				    Temp := Wopr_List.Root;
				    Wopr_List.Nbr := Wopr_List.Nbr - 1;
				    if Loose then
				       Loose := False;
				    end if;
				 else

				    Wopr_List.Root := null;
				    Temp := null;
				    Wopr_List.Current := null;
				    Wopr_List.Nbr := Wopr_List.Nbr - 1;
				    if Loose then
				       Loose := False;
				    end if;
				    exit Main;

				 end if;

			      else


				 Prev.next := Temp.Next;
				 Temp := Prev.Next;
				 Wopr_List.Nbr := Wopr_List.Nbr - 1;
				 if Loose then
				    Loose := False;
				 end if;
			      end if;





			   else

			      Prev := Temp;
			      Temp := Temp.Next;

			   end if;
			   
			else
			   Temp := Temp.Next;
			end if;
		     end loop;
		  end loop main;
		  
		  
		  
                  if Wopr_List.Current /= null then
                     Clear(Wopr_List.Current.Wopr.Weapons);
                     Wopr_List.Current.Wopr.Weapons := Local;
                  end if;

                  Clear(Local);
               end if;

               exit;
            end if;
            Wopr_List.Current := Wopr_List.Current.Next;
         end loop;

      end Launch_All;
   end Sgbd_Type;
   
   
   procedure Print (GPS_Coordonates : GPS_Coordonates_Type) is
      Longitude : Longitude_Coordonate_Type := GPS_Coordonates.Longitude;
      Latitude  : Latitude_Coordonate_Type := GPS_Coordonates.Latitude;
   begin
      Text_Io.Put("Long ");
      Float_Text_Io.Put(Longitude.Degr_Lon, 3, 0, 0);Text_Io.Put("°");
      Float_Text_Io.Put(Longitude.Minu_Lon, 2, 0, 0);Text_Io.Put(''');
      Float_Text_Io.Put(Longitude.Seco_Lon, 2, 0, 0);Text_Io.Put('"');
      Text_Io.Put(", Lat ");
      Float_Text_Io.Put(Latitude.Degr_Lat, 3, 0, 0);Text_Io.Put("°");
      Float_Text_Io.Put(Latitude.Minu_Lat, 2, 0, 0);Text_Io.Put(''');
      Float_Text_Io.Put(Latitude.Seco_Lat, 2, 0, 0);Text_Io.Put('"');
      Text_Io.New_Line;
   end Print;

   
   
   Population_Filename : constant String := "data/worldcitiespop.txt";
   Error_Count : Integer := 0;
   File : Text_Io.File_Type;
   Population_Ouest : Long_Long_Integer := 0;
   Population_Est : Long_Long_Integer := 0;
   Separator      : Character := Character'Val(44);
begin
   Text_Io.Put_Line("Open File " & Population_Filename);
   Text_Io.Open(File, Text_Io.In_File, Population_Filename);
   Text_Io.Put_Line("reading File " & Population_Filename);
   while not Text_Io.End_Of_File(File) loop
      
	 declare
	    Line   : constant String := Text_Io.Get_Line(File);
	    Nation : Nation_Type;
	    
	    Last_Separator : Natural := 0;	    	  
	    
	    
	 begin
	    
	    --Last_Separator := Fixed.Index(Line, "" & Separator, Last_Separator+1) + 1;	       
	    --Fixed.Move(Line(Last_Separator..Fixed.Index(Line, "" & Separator, Last_separator) - 1), Nation.Name, Error, left);
	    
	    for I in 1..5 loop	    
	       Last_Separator := Fixed.Index(Line, "" & Separator, Last_Separator+1)+1;	       	       
	    end loop;
	    
	    
	    
	    Nation.Latitude := Decimal_Latitude_Type'Value(Line(Last_Separator..Fixed.Index(Line, "" & Separator, Last_separator) - 1));	    	    	    	    
	    Last_Separator := Fixed.Index(Line, "" & Separator, Last_Separator+1) + 1;
	    
	    
	    Nation.Longitude := Decimal_Longitude_Type'Value(Line(Last_Separator..Line'last));--Fixed.Index(Line, "" & Separator, Last_separator) - 1)
	    
	    Nation.Gps_Coordonates := To_GPS(Nation.Longitude, Nation.Latitude);
	    --Print(Nation.GPS_Coordonates);

	    
	    	    
	    
	    Last_Separator := 0;
	    for I in 1..4 loop
	       Last_Separator := Fixed.Index(Line, "" & Separator, Last_Separator+1) + 1;	       	       
	    end loop;
	    
	    
	    
	    begin
	       Nation.Population := Long_Long_Integer'Value(Line(Last_Separator..Fixed.Index(Line, "" & Separator, Last_separator) - 1));	    	    
	       if Nation.Population > 270000 then
		  case Side_Of(Nation.Gps_Coordonates) is
		     when Ouest =>
			Population_Ouest := Population_Ouest + Nation.Population;
			if Population_Ouest < 3_500_000_000 then		       
			   All_Populations := All_Populations & Nation;
			   --Text_Io.Put_Line("Add Ouest ");
			end if;
		     when Est =>		     			
			Population_Est := Population_Est + Nation.Population;
			if Population_Est < 3_500_000_000 then
			   All_Populations := All_Populations & Nation;
			   --Text_Io.Put_Line("Add Est");
			end if;
		  end case;
	       end if;
	    end;
	    
	    
	 exception
	    
	    when Constraint_Error =>
	       Error_Count := Error_Count + 1;
	       
	 end;
	 
   end loop;
   Text_Io.Close(File);
   Text_Io.Put_Line("Error Count = " & Integer'Image(Error_Count));
   Text_Io.Put_Line("Length = " & Index_type'Image(Last_Index(All_Populations)));
end Warborg.Database;
