-- Warborg is Wargames playing on network
-- Copyright (C) 2011 Manuel De Girardi

-- This Program is Free Software: You Can Redistribute It and/or Modify
-- It Under The Terms of The GNU General Public License As Published By
-- The Free Software Foundation, Either Version 3 of The License, or
-- (at Your Option) Any Later Version.

-- This Program is Distributed in The Hope That It Will Be Useful,
-- But WITHOUT ANY WARRANTY; Without Even The Implied Warranty of
-- MERCHANTABILITY or FITNESS for A PARTICULAR PURPOSE.  See The
-- GNU General Public License for More Details.

-- You Should Have Received A Copy of The GNU General Public License
-- Along with This Program.  if not, See <Http://Www.Gnu.Org/Licenses/>.

with Warborg.World;
use Warborg.World;
with Warborg.Nation.Manager;
use Warborg.Nation.Manager;
use Warborg.Nation;
with Warborg.Joshua;
use Warborg.Joshua;
with Warborg.Weapon;
with Warborg.Weapon.Manager;
use Warborg.Weapon;
with Warborg.Common;

package Warborg.Database is
   pragma Elaborate_Body(Warborg.Database);
   use Warborg, Warborg.Common, Warborg.Common.My_Map;
   

   
   
   type List_Type is limited private;
   type Node_Type is private;
   type Node_Access is limited private;

   protected type Sgbd_Type is

      entry Get_Wopr(Logname : in String;
                     Wopr : out Joshua_Type;
                     Success : out Boolean);
      entry Add_Wopr(Logname : in String;
                     Wopr : in Joshua_Type;
                     Success : out boolean);
      entry Get_Enemy(Logname : in String;
                      Missiles : out Weapon.Manager.Vector);
      entry Add_Missile(Logname : in String;
                       Missile : in Missile_Type;
                       Success : out Boolean);
      entry Launch_One(Logname : in String;
                       Missile_Id : in Missile_Vector_Index_type);

      entry Launch_All(Logname : in String);

   private
      Missile_Attributes : Missile_Attributes_Type;
      Launched_Missile_Attributes : Missile_Attributes_Type;
      Wopr_Attributes   : Wopr_Attributes_Type;
      Temp : Node_Access;
      Prev : Node_Access;
      Loose : Boolean := False;
      Back : Natural := 0;
      Local : Weapon.Manager.Vector;
      Allway   : Boolean := True;
      Wopr_List : List_Type;
   end Sgbd_Type;

private      
   type Node_Access is
     access Node_Type;
   type Node_Type is
      record
         Player_Name : String_Access;
         Wopr        : Joshua_Type;
         Next        : Node_Access;

      end record;
   type List_Type is
      record
         Root : Node_Access;
         Current : Node_Access;
         Nbr  : Natural := 0;
      end record;





end Warborg.Database;
