with Warborg.Xborg;
with Gtk.Main;



with Ada.Strings.Fixed;
use Ada.Strings;
with Ada.Text_Io;

with Ada.Float_Text_Io;
use Ada;
with Warborg.Common;
use Warborg.Common;
with Warborg.World;
use Warborg.World;

with Warborg.User.Manager;
with Warborg.User.Util;
use Warborg.User;
with Warborg.Nation.Manager;
use Warborg.Nation.Manager;
use Warborg.Nation;
with Warborg.Joshua;
with Warborg.Weapon;
use Warborg;

with Gnat.SHA1;
use Gnat;
with Gnat.Os_Lib, Gnat.Sockets;
use Gnat, Gnat.Sockets;

with Interfaces.C;
use Interfaces;

use Warborg.World;

package body Warborg.Terminal is
   
   
   
   
   
   
   task type Terminal_Type(Channel : Stream_Access) is
      --  entry Help;
      --  entry Logon(Wopr : in out Joshua.Joshua_Type);
      --  entry New_Game(Wopr : in out Joshua.Joshua_Type);
      --  entry Defcon_Up(Wopr : in out Joshua.Joshua_Type);
      --  entry Defcon_Down(Wopr : in out Joshua.Joshua_Type);
      entry X;
      entry Receive(Char : in Character);
      entry Halt;
   end Terminal_Type;
   
   
   function System(Command : in String) return Integer;
   pragma Import (C, System, "system");
   
   function Clear return boolean is
      Errno : Integer := 0;
   begin
      Errno := System("clear" & Character'Val(0));
      return Errno = 0;
   end Clear;
   
   
   procedure Print(Text : in String; Rate : in Duration := 0.05; Quiet : in Boolean := true) is
   begin
      if Text'Length > 0 then
	 for I in Text'Range loop
	    Text_Io.Put(Text(I));
	    if not Quiet and Text(I) = Character'Val(32) then
	       Text_Io.Put(Character'Val(7));
	       null;
	    end if;
	    delay Rate;
	 end loop;
      end if;
   end Print;                              
      
   
   
   use Warborg.Common, Warborg.Common.My_Map;
   
   
   task body Terminal_Type is
      
      
      Success : Boolean;
      End_Of_Task : Boolean := False;
      --Decimal_Longitude : Decimal_Longitude_Type;
      --Decimal_Latitude  : Decimal_Latitude_Type;
      --GPS_Coordonates   : GPS_Coordonates_Type;
   begin
      Text_Io.New_Line;	    
      Print("Appuyez sur F5 pour démarré l'interface graphique.", 0.0);	 
      Text_Io.New_Line;	    
      while not End_Of_Task loop	 
	 --Success := Clear;
	 --  Print("Bonjour, le monde !", 0.0);
	 --  Text_Io.New_Line;	    
	 --  Print("Appuyez sur F1 pour obtenir de l'aide.", 0.0);
	 --  Text_Io.New_Line;	    
	 --  Print("Appuyez sur F2 pour lancer la session", 0.0);
	 --  Text_Io.New_Line;	    
	 --  Print("Appuyez sur F3 pour passer au defcon suivant.", 0.0);
	 --  Text_Io.New_Line;	    
	 --  Print("Appuyez sur F4 pour passer au defcon précédent.", 0.0);
	 
	 --  Print("Appuyez sur F6 pour faire une nouvelle partie", 0.0);
	 
	 
	 select
	    --  accept Logon(Wopr : in out Joshua.Joshua_Type) do
	 --        Text_Io.Put("Enter decimal latitude : ");
	 --        Float_Text_Io.Get(Decimal_Latitude);
	 --        Text_Io.Put("Enter decimal longitude : ");
	 --        Float_Text_Io.Get(Decimal_Longitude);
	 --        GPS_Coordonates := To_Gps(Decimal_Longitude, Decimal_Latitude);	       
	 --        Wopr.Wopr_Attributes.Source := To_Map_Coordonates(GPS_Coordonates);
	 --        Command_type'Output(Channel, Wopr_Create);	       
         --        Joshua.Wopr_Attributes_Type'Output(Channel, Wopr.Wopr_Attributes);
         --        Text_Io.Put_Line("Wopr_Create");
         --        Success := Boolean'Input(Channel);
	 --        if Success then
	 --  	  wopr.Wopr_Attributes.Side := Joshua.Side_Type'Input(Channel);
	 --        end if;
	 --     end Logon;
	 --  or
	 --     accept New_Game(Wopr : in out Joshua.Joshua_Type);
	 --  or
	 --     accept Defcon_Up(Wopr : in out Joshua.Joshua_Type);
	 --  or
	 --     accept Defcon_Down(Wopr : in out Joshua.Joshua_Type);
	 --  or
      	    
	    accept X;
	    Text_Io.New_Line;	    
	    Print("Good luck!", 0.2, false);
	 or
	    accept Receive(Char : in Character) do
	       case Char is
		  when others =>
		     null;
	       end case;
	    end Receive;
	 or
	    accept Halt;
	    Text_Io.New_Line;	    
	    Print("Bye evry body!", 0.01, false);	    
	    End_Of_Task := True;
	 end select;	 
      end loop;
      
      
   end Terminal_Type;
   
   
   

   
   
   
   
   
   
   
   procedure Open(Address : in String;
		  Name    : in String) is
      
      Passwd  : SHA1.Message_Digest;
      Ctrl    : SHA1.Message_Digest;
      Response: Command_Type;

      Wopr : Joshua.Joshua_Type;

      
      Logname : Logname_Type := (others => Character'Val(32));
      Last    : Natural := 0;      
      Success : Boolean := False;
      
      Term_Address      : Sock_Addr_Type;
      Socket            : Socket_Type;
      Channel           : Stream_access;
      
      Line, Output : String_Access;
      
   begin
      
      if Address'Length /= 0 then
	 Term_Address.Addr := Addresses (Get_Host_By_Name (Address));
      else
	 Term_Address.Addr := Addresses (Get_Host_By_Name ("localhost"));
      end if;
      
      Term_Address.Port := 5872;
      Create_Socket (Socket);
      
      Set_Socket_Option
	(Socket,
      Socket_Level,
	 (Reuse_Address, True));
      
      delay 0.2;

      Connect_Socket (Socket, Term_Address);
      
      Channel :=  stream(Socket);
      
      
      loop
	 
	 if name'Length /= 0 then
	    Fixed.Move(Name,  Logname, Error, Left);
	 else
	    begin
	    loop
	       Text_Io.New_Line;
	       Text_Io.Put("logname : ");
	       Text_Io.Get_Line(Logname, Last);
	       if Last /= 0 and Last < Logname_Type'Length then
		  exit;
	       end if;
	    end loop;
	    Text_Io.New_Line;	    
	    end;      
	 end if;
	 
	 Line := new String ' (String'Input(Channel));
	 Text_Io.Put(Line.all);
	 Warborg.User.util.Get_Passwd(Passwd);      
	 Text_Io.New_Line;
	 --Text_Io.Put("envoie commande");
	 Command_Type'Output(Channel, Logon);
	 --Text_Io.Put("envoie logname");
	 Logname_type'Output(Channel, logname);
	 --Text_Io.Put("envoie SHA1");
	 SHA1.Message_Digest'Output(Channel, Passwd);
	 --Text_Io.Put("attend response");
	 Response := Command_Type'Input(Channel);
	 case Response is
	    when Ctrl_User =>	    	       
	       Text_Io.Put("Verify : ");
	       Util.Get_Passwd(Ctrl);
	       Text_Io.New_Line;
	       if Ctrl = Passwd then
		  Command_Type'Output(Channel, Logon);
		  String'Output(Channel, logname);
		  SHA1.Message_Digest'Output(Channel, Passwd);		  
		  Response := Command_Type'Input(Channel);
		  case Response is
		     when Ctrl_user =>
			null;
		     when Login =>						
			exit;		       
		     when others =>
			null;
		  end case;
	       end if;
	    when Login =>
	       --Text_Io.Put("Receive login : ");
	       exit;
	    when others =>
	       null;
	 end case;	    
      end loop;
      --Text_Io.Put("Attend WOPR exist : ");
      Success := Boolean'Input(Channel);                        
      
      while not Success loop
	 while not Success loop
	    
	    Output := new String ' (String'Input(Channel));
	    Print(output.all, 0.00, True);
	    line := new String ' (Text_Io.Get_Line);
	    String'Output(Channel, line.all);
	    success := Boolean'Input(Channel);
	 end loop;
	 
	 --Text_Io.Put("Attend Side");
	 wopr.Side := Side_Type'Input(Channel);
	 --Text_Io.Put_Line("receive side");
	 Text_Io.Put_Line("Terminal wopr side := " & Side_Type'Image(Wopr.Side));
      end loop;
            
      
      
      loop
	 declare
	    Terminal : Terminal_Type(Channel);
	 begin
	    
	 
	    begin
	       loop
		  declare
		     Char : Character;
		  begin
		     
		     Text_Io.Get_Immediate(Char);
		     case Char is
			when Character'Val(27) =>
			   Text_Io.Get_Immediate(Char);
			   case Char is
			      when Character'Val(27) =>               
				 Terminal.Receive(Char);
			      when Character'Val(91) =>
				 Text_Io.Get_Immediate(Char);                 
				 case Char is
				    when Character'Val(49) =>
				       Text_Io.Get_Immediate(Char);                   
				       case Char is
					  when Character'Val(53) =>
					     Text_Io.Get_Immediate(Char);                 
					     null;Text_Io.Put_Line(" -- F5");
					     --Terminal.X;
					     declare
						
						Borg : Warborg.Xborg.Xborg_Application;
					     begin
						Gtk.Main.Init;
						Xborg.Initialize(borg, Channel, wopr);
						Gtk.Main.Main;
					     end;
					     Text_Io.New_Line;	    
					     Print("Appuyez sur Ctrl+D pour terminer le dialogue.", 0.01, False);
	    
					  when Character'Val(55) =>
					     Text_Io.Get_Immediate(Char);                 
					     null;Text_Io.Put_Line(" -- F6");                             
					     --Terminal.New_Game(Wopr);
					  when Character'Val(56) =>
					     null;Text_Io.Put_Line(" -- F7");
					  when Character'Val(57) =>
					     null;Text_Io.Put_Line(" -- F8");
					  when Character'Val(126) =>                        
					     null;Text_Io.Put_Line(" -- begin");
					  when others =>
					     null;
				       end case;                 
				    when Character'Val(50) =>                       
				       Text_Io.Get_Immediate(Char);                   
				       case Char is
					  when Character'Val(48) =>
					     null;Text_Io.Put_Line(" -- F9");
					  when Character'Val(49) =>
					     null;Text_Io.Put_Line(" -- F10");
					  when Character'Val(51) =>
					     null;Text_Io.Put_Line(" -- F11");
					  when Character'Val(52) =>
					     null;Text_Io.Put_Line(" -- F12");
					  when Character'Val(53) =>                               
					     null;Text_Io.Put_Line(" -- Maj+F1");
					  when Character'Val(54) =>                               
					     null;Text_Io.Put_Line(" -- Maj+F2");
					  when Character'Val(56) =>                               
					     null;Text_Io.Put_Line(" -- Maj+F3");
					  when Character'Val(57) =>
					     null;Text_Io.Put_Line(" -- Maj+F4");
					  when Character'Val(126) =>
					     null;Text_Io.Put_Line(" -- insert");
					  when others =>
					     null;
				       end case;                                                                    
				    when Character'Val(51) =>                       
				       null;Text_Io.Put_Line(" -- del");                    
				       Text_Io.Get_Immediate(Char);      
				    when Character'Val(52) =>                       
				       null;Text_Io.Put_Line(" -- end");                    
				       Text_Io.Get_Immediate(Char);      
				    when Character'Val(53) =>
				       Text_Io.Put_Line(" -- page up");
				       Text_Io.Get_Immediate(Char);      
				    when Character'Val(54) =>
				       Text_Io.Put_Line(" -- page down");
				       Text_Io.Get_Immediate(Char);      
				    when Character'Val(91) =>
				       null;
				    when Character'Val(65) =>
				       null;Text_Io.Put_Line(" -- up");
				    when Character'Val(66) =>
				       null;Text_Io.Put_Line(" -- down");
				    when Character'Val(67) =>
				       null;Text_Io.Put_Line(" -- right");
				    when Character'Val(68) =>
				       null;Text_Io.Put_Line(" -- left");				    
				    when others =>
				       null;
				 end case;
			      when Character'Val(79) =>
				 Text_Io.Get_Immediate(Char);                   
				 case Char is
				    when Character'Val(80) =>
				       null;Text_Io.Put_Line(" -- F1");                                
				       --Terminal.help;
				    when Character'Val(81) =>
				       null;Text_Io.Put_Line(" -- F2");
				       --Terminal.Logon(Wopr);
				    when Character'Val(82) =>
				       null;Text_Io.Put_Line(" -- F3");                                
				       --Terminal.Defcon_Up(Wopr);
				    when Character'Val(83) =>
				       null;Text_Io.Put_Line(" -- F4");
				       --Terminal.Defcon_Down(Wopr);					  
				    when others =>
				       null;
				 end case;

			      when others =>
				 null;
			   end case;			   
			when others =>
			   Terminal.Receive(Char);
		     end case;
		  exception
		     when Text_Io.End_Error =>
			Terminal.Halt;
			
			exit;
		  end;
	       end loop;
	    end;
	    exit;
	 end;
      end loop;
   end Open;
   
   
end Warborg.Terminal;
