with Ada.Streams.Stream_Io;
use Ada.Streams;
with Text_Io;
use Text_Io;
package body Warborg.User.Manager is
   
   Users_Filename : String_Access;
   
   procedure Initialize(Filename : in String) is
   begin
      Users_Filename := new String ' (Filename);
   end Initialize;
   
   function Add_User(Logname : in String;
		     Passwd : in Message_Digest) return Boolean is

      Users_File : Stream_Io.File_Type;
      Users_Stream : Stream_Io.Stream_Access;

      Old, Current : User_Type;
      Success : Boolean := False;
   begin
      Text_Io.Put_line("Add user : logname : " & Logname);
      Initialize(Current, Logname);
      Text_Io.Put_line("Add user : logname : " & Current.Logname);
      Set_Pass(Current, Passwd);
      begin
	 Stream_IO.open(users_File, Stream_Io.In_File, Users_Filename.all);
	 
	 users_stream := Stream_IO.Stream(users_File);
	 while not Stream_Io.End_Of_File(Users_File) loop
	    User_Type'read(Users_Stream, old);
	    if Current.Logname = Old.Logname then
	       Stream_IO.Close(Users_File);
	       return False;
	    end if;
	 end loop;
	 Stream_IO.Close(Users_File);
      exception
	 when Stream_Io.Name_Error =>
	    Stream_IO.create(users_File, Stream_Io.out_File, Users_Filename.all);
	    Stream_IO.Close(Users_File);
      end;

      Stream_IO.open(users_File, Stream_Io.append_File, Users_Filename.all);
      users_stream := Stream_IO.Stream(users_File);
      User_Type'write(Users_Stream, Current);
      Stream_IO.Close(Users_File);
      return True;
   end add_user;


   function Check_passwd(Logname : in String;
			 Passwd : in Message_Digest) return Boolean is
      Users_File : Stream_Io.File_Type;
      Users_Stream : Stream_Io.Stream_Access;


      Old, Current : User_Type;

   begin
      
      
      Initialize(Current, Logname);
      Set_Pass(Current, Passwd);
      
      Stream_IO.open(users_File, Stream_Io.In_File, Users_Filename.all);
      
      users_stream := Stream_IO.Stream(users_File);

      while not Stream_Io.End_Of_File(Users_file) loop
	 User_Type'read(Users_Stream, old);
	 
	 if Current.Logname = Old.Logname then
	    
	    if Check_Pass(Old, passwd) then
	    --if Current.passwd = Old.passwd then

	       Stream_IO.Close(Users_File);

	       return True;

	    else

	       Stream_IO.Close(Users_File);
	       return False;
	    end if;
	 end if;
      end loop;
      
      Stream_IO.Close(Users_File);
      return False;
   exception
      when others =>
	 return False;
   end Check_passwd;


end Warborg.User.Manager;
