
package Warborg.User is
   
   use Gnat.SHA1;
   subtype Logname_Type is String (1..32);
   type User_Type is tagged
      record
	 Logname : Logname_Type;
	 Passwd : Message_Digest;
      end record;         
   
   procedure Initialize(User : out User_Type;
			Name : in Logname_Type);
   -- Get player named "Name".
   

   
   procedure Set_Pass(User : in out User_Type;
		      Pass : in Message_Digest);
   -- Set password for player.
   
   function Check_Pass(User : in User_Type;
		       Pass : in Message_Digest) return Boolean;
   -- Return True is getted password is valid. False else.      
   
end Warborg.User;
