with Ada.Text_Io;

with Ada.Float_Text_Io;
use Ada;

with Interfaces.C;
use Interfaces.C;
package body Warborg.World is   
   
   type Double_Access is access all Double;
   
   function Modf (X : in Double; Iptr : in Double_access) return Double;
   pragma Import(C, Modf, "modf");
   function To_GPS(Decimal_longitude : in Decimal_Longitude_Type;
		   Decimal_Latitude  : in Decimal_Latitude_Type)  return GPS_Coordonates_Type is
      
      GPS_Coordonates : GPS_Coordonates_Type;
      Longitude : Longitude_Coordonate_Type;
      Latitude  : Latitude_Coordonate_Type;
      
      Local : Double := 0.0;
      
      Degree_Int : Double_Access := new Double ' (0.0);      
      Minute_Flo : Double := 0.0;
      Minute_Int : Double_Access := new Double ' (0.0);      
      Second_flo : Double := 0.0;      
            
      
   begin
      
      -- Longitude convertion
      --
      Local := Double(Decimal_Longitude);
      if Decimal_Longitude < 0.0 then
      	 local := local * (-1.0);
      end if;
                  
      Minute_Flo := 60.0 * Modf(Local, Degree_Int);            
      
      Second_Flo := 60.0 * Modf(Minute_Flo, Minute_int);
      
      if Decimal_Longitude < 0.0 then
	 Degree_Int.all := Degree_Int.all * (-1.0);

      end if;            
      Longitude.Degr_Lon := Float(Degree_Int.all);
      Longitude.Minu_Lon := Float(Minute_Int.all);
      Longitude.Seco_Lon := Float(Second_Flo);
      
           
      Local := Double(Decimal_Latitude);
      if Decimal_Latitude < 0.0 then
      	 local := local * (-1.0);
      end if;
      
      
      Minute_Flo := 60.0 * Modf(Local, Degree_Int);            
      
      Second_Flo := 60.0 * Modf(Minute_Flo, Minute_int);
      
      if Decimal_Latitude < 0.0 then
	 Degree_Int.all := Degree_Int.all * (-1.0);

      end if;            
      Latitude.Degr_Lat := Float(Degree_Int.all);
      
      
      -- En effet Minute_Int vaut : NaN**************
      
      Latitude.Minu_Lat := Float(Minute_Int.all);
      
      
      Latitude.Seco_Lat := Float(Second_Flo);

      
      GPS_Coordonates := (Longitude, Latitude);
      return GPS_Coordonates;
   end To_GPS;         
   
      function Side_Of(Position : in GPS_Coordonates_Type) return Side_Type is
   begin
      if Position.Longitude.Degr_Lon > 0.0 then
	 return Est;
      end if;
      if Position.Longitude.Degr_Lon < 0.0 then
	 return Ouest;
      end if;      
      if Position.Longitude.minu_Lon > 0.0 then
	 return Est;
      end if;
      if Position.Longitude.minu_Lon < 0.0 then
	 return Ouest;
      end if;
      if Position.Longitude.seco_Lon > 0.0 then
	 return Est;
      end if;
      if Position.Longitude.seco_Lon < 0.0 then
	 return Ouest;
      end if;
      return Est;
   end Side_of;

   function "=" (Left, Right : in GPS_Coordonates_Type) return Boolean is
   begin
      return (Left.Longitude = Right.Longitude) and
	(Left.Latitude = Right.Latitude);
   end "=";
   
      
end Warborg.World;
