
package Warborg.World is   
   
   
   subtype Longitude_Degree_Type is Float range -180.0..180.0;
   subtype Longitude_Minute_Type is Float range 0.0..60.0;
   subtype Longitude_Second_Type is Float range 0.0..60.0;
   
   type Longitude_Coordonate_Type is
      record
	 Degr_Lon : Longitude_Degree_Type := 0.0;
	 Minu_Lon : Longitude_Minute_Type := 0.0;
	 Seco_Lon : Longitude_Second_Type := 0.0;
      end record;
   
   subtype Latitude_Degree_Type is Float range -90.0..90.0;
   subtype Latitude_Minute_Type is Float range 0.0..60.0;
   subtype Latitude_Second_Type is Float range 0.0..60.0;   
   
   type Latitude_Coordonate_Type is
      record
	 Degr_Lat : Latitude_Degree_Type := 0.0;
	 Minu_Lat : Latitude_Minute_Type := 0.0;
	 Seco_Lat : Latitude_Second_Type := 0.0;
      end record;

   type GPS_Coordonates_Type is
      record
	 Longitude : Longitude_Coordonate_Type;
	 Latitude  : Latitude_Coordonate_Type;
      end record;
   
   subtype Decimal_Longitude_Type is Float range -180.0..180.0;
   subtype Decimal_Latitude_Type is Float range -90.0..90.0;   
   
   
   function To_GPS(Decimal_longitude : in Decimal_Longitude_Type;
		   Decimal_Latitude  : in Decimal_Latitude_Type)  return GPS_Coordonates_Type;
   
   type Side_Type is (Est, Ouest);
   function Side_Of(Position : in GPS_Coordonates_Type) return Side_Type;
   
   function "=" (Left, Right : in GPS_Coordonates_Type) return Boolean;
   
   
end Warborg.World;
