with Ada.Strings.Fixed;
use Ada.Strings;
with Ada.Text_Io;

with Ada.Float_Text_Io;
use Ada;

with Warborg.World;
use Warborg.World;
with Warborg.Common;
with Warborg.User.Manager;
with Warborg.User.Util;
use Warborg.User;
with Warborg.Nation.Manager;
use Warborg.Nation.Manager;
use Warborg.Nation;
with Warborg.Joshua;
use Warborg;

with Gnat.SHA1;
use Gnat;
procedure Test is     
   
   use Warborg.Common;use Warborg.Common.My_Map;
   Test_Set : array (1..9) of GPS_Coordonates_Type := 
     (1 => (Longitude => (179.0, 59.0, 59.0), 
   	    Latitude  => (89.0, 59.0, 59.0)
   	   ),
      2 => (Longitude => (-179.0, 59.0, 59.0), 
   	    Latitude  => (89.0, 59.0, 59.0)
   	   ),
      3 => (Longitude => (179.0, 59.0, 59.0), 
   	    Latitude  => (-89.0, 59.0, 59.0)
   	   ),
      4 => (Longitude => (-179.0, 59.0, 59.0), 
   	    Latitude  => (-89.0, 59.0, 59.0)
   	   ),
      5 => (Longitude => (1.0, 59.0, 59.0), 
   	    Latitude  => (1.0, 59.0, 59.0)
   	   ),
      6 => (Longitude => (-1.0, 59.0, 59.0), 
   	    Latitude  => (1.0, 59.0, 59.0)
   	   ),
      7 => (Longitude => (1.0, 59.0, 59.0), 
   	    Latitude  => (-1.0, 59.0, 59.0)
   	   ),
      8 => (Longitude => (-1.0, 59.0, 59.0), 
   	    Latitude  => (-1.0, 59.0, 59.0)
   	   ),      
      9 => (Longitude => (0.0, 0.0, 0.0), 
   	    Latitude  => (0.0, 0.0, 0.0)
   	   )
     );      
   
   
   procedure Print (Map_Coordonates : in Map_Coordonates_Type) is
   begin
      Text_Io.Put("X = "); Float_Text_Io.Put(Map_Coordonates.X);
      Text_Io.Put(", Y = "); Float_Text_Io.Put(Map_Coordonates.Y);
      Text_Io.New_Line;	 	 
   end Print;
   
   GPS_Coordonates : GPS_Coordonates_Type;
   
   procedure Print (GPS_Coordonates : GPS_Coordonates_Type) is
      Longitude : Longitude_Coordonate_Type := GPS_Coordonates.Longitude;
      Latitude  : Latitude_Coordonate_Type := GPS_Coordonates.Latitude;
   begin
      Text_Io.Put("Long ");
      Float_Text_Io.Put(Longitude.Degr_Lon, 3, 0, 0);Text_Io.Put("°");
      Float_Text_Io.Put(Longitude.Minu_Lon, 2, 0, 0);Text_Io.Put(''');
      Float_Text_Io.Put(Longitude.Seco_Lon, 2, 0, 0);Text_Io.Put('"');
      Text_Io.Put(", Lat ");
      Float_Text_Io.Put(Latitude.Degr_Lat, 3, 0, 0);Text_Io.Put("°");
      Float_Text_Io.Put(Latitude.Minu_Lat, 2, 0, 0);Text_Io.Put(''');
      Float_Text_Io.Put(Latitude.Seco_Lat, 2, 0, 0);Text_Io.Put('"');
      Text_Io.New_Line;
   end Print;
   
   Map_Coordonates : Map_Coordonates_Type := (0.0, 0.0);
   
begin
   
   for I in Test_Set'range loop            
      declare	 	 
   	 Map_Coordonates : Map_Coordonates_Type := (0.0, 0.0);
      begin
   	 Text_Io.Put_Line("Test" & Natural'Image(I));
   	 Map_Coordonates := To_Map_Coordonates(Test_Set(I));
   	 Print(Map_Coordonates);
      end;	       	 	 
   end loop;
   
   Text_Io.New_Line;
   Text_Io.Put_Line("Converting decimal to Degree.Minutes.Seconds");
   
   GPS_Coordonates := To_GPS(-0.0, -0.0);
   Print(GPS_Coordonates);
   Map_Coordonates := To_Map_Coordonates(GPS_Coordonates);
   Print(Map_Coordonates);
   
   Text_Io.New_Line;
   Text_Io.Put_Line("Initialize users filename");
   User.Manager.Initialize("users.bin");
   
   --  loop
   --     Text_Io.New_Line;
   --     Text_Io.Put_Line("Add user...");

   --     declare	 
   --  	 Logname : Logname_Type := (others => Character'Val(32));
   --  	 Last    : Natural := 0;
   --  	 Passwd  : SHA1.Message_Digest;
   --  	 Ctrl    : SHA1.Message_Digest;
   --  	 Success : Boolean := False;
   --     begin
   --  	 loop
   --  	    Text_Io.New_Line;
   --  	    Text_Io.Put("Logname : ");
   --  	    Text_Io.Get_Line(Logname, Last);
   --  	    if Last /= 0 then
   --  	       exit;
   --  	    end if;
   --  	 end loop;
   --  	 Text_Io.New_Line;
   --  	 Text_Io.Put("Passwd : ");
   --  	 Util.Get_Passwd(Passwd);
   --  	 Text_Io.New_Line;
   --  	 Text_Io.Put("Verify : ");
   --  	 Util.Get_Passwd(Ctrl);
   --  	 if Ctrl = Passwd then
   --  	    Text_Io.New_Line;
   --  	    Success := Manager.Add_User(Logname, Passwd);
   --  	    if Success then
   --  	       exit;
   --  	    end if;
   --  	 end if;
   --     exception
   --  	 when Manager.User_Exist =>
   --  	    Text_Io.Put_Line("User already registered.");
   --     end;
   --  end loop;
   
   
   --  loop
   --     Text_Io.New_Line;
   --     Text_Io.Put_Line("Check user passwd :");
      
   --     declare
	 	 
   --  	 Logname : Logname_Type := (others => Character'Val(32));
   --  	 Last    : Natural := 0;
   --  	 Passwd  : SHA1.Message_Digest;
   --  	 Success : Boolean := False;
   --     begin
   --  	 loop
	    
   --  	    Text_Io.New_Line;
   --  	    Text_Io.Put("Logname : ");
   --  	    Text_Io.Get_Line(Logname, Last);
   --  	    if Last /= 0 then
   --  	       exit;
   --  	    end if;
   --  	 end loop;
   --  	 Text_Io.New_Line;
   --  	 Text_Io.Put("Passwd : ");
   --  	 Util.Get_Passwd(Passwd);	 
   --  	 Text_Io.New_Line;
   --  	 Success := User.Manager.Check_passwd(Logname, Passwd);
   --  	 if Success then
   --  	    exit;
   --  	 else	    
   --  	    Text_Io.Put("Bad Passwd");
   --  	 end if;
   --     end;
   --  end loop;
   
   declare
      
      All_Populations : Nation.Manager.Vector;
      Population_Filename : constant String := "data/cities15000.txt";
      Error_Count : Integer := 0;
      File : Text_Io.File_Type;
      
      Joshua : Warborg.Joshua.Joshua_Type;
      
      
   begin
      
      Text_Io.Open(File, Text_Io.In_File, Population_Filename);
      while not Text_Io.End_Of_File(File) loop
   	 declare
   	    Line   : constant String := Text_Io.Get_Line(File);
   	    Nation : Nation_Type;
	    
   	    Last_Separator : Natural := 0;	    	  
	    
	    
   	 begin
   	    Last_Separator := Fixed.Index(Line, "" & Character'Val(9), Last_Separator+1) + 1;	       
   	    Fixed.Move(Line(Last_Separator..Fixed.Index(Line, "" & Character'Val(9), Last_separator) - 1), Nation.Name, Error, left);
   	    
	    
   	    for I in 1..3 loop
   	       Last_Separator := Fixed.Index(Line, "" & Character'Val(9), Last_Separator+1) + 1;	       	       
   	    end loop;
	    Nation.Latitude := Decimal_Latitude_Type'Value(Line(Last_Separator..Fixed.Index(Line, "" & Character'Val(9), Last_separator) - 1));
	    
   	    Last_Separator := Fixed.Index(Line, "" & Character'Val(9), Last_Separator+1) + 1;
	    Nation.Longitude := Decimal_Longitude_Type'Value(Line(Last_Separator..Fixed.Index(Line, "" & Character'Val(9), Last_separator) - 1));
	    
	    
	    Last_Separator := 0;
	    for I in 1..12 loop
   	       Last_Separator := Fixed.Index(Line, "" & Character'Val(9), Last_Separator+1) + 1;	       	       
   	    end loop;
	    Nation.Population := Long_Long_Integer'Value(Line(Last_Separator..Fixed.Index(Line, "" & Character'Val(9), Last_separator) - 1));	    	    
	    
	    
	    All_Populations := All_Populations & Nation;
	    
   	 exception
	    
	    when Constraint_Error =>
	       Error_Count := Error_Count + 1;
   	 end;
      end loop;
      Text_Io.Close(File);
      Text_Io.Put_Line("Error Count = " & Integer'Image(Error_Count));
      Text_Io.Put_Line("Length = " & Integer'Image(Last_Index(All_Populations)));
      Text_Io.Put_Line("Press Enter to continue.");
      Text_Io.Skip_Line;
      declare
	 Nation : Nation_Type;
	 Total_Population : Long_Long_Integer := 0;
      begin
	 for I in 1..Last_Index(All_Populations) loop
	    Nation := Element(All_Populations, I);
	    Text_Io.Put_Line("Land name : " & Nation.Name(1..Fixed.Index_Non_Blank(Nation.Name, Backward)));
	    Text_Io.Put_Line("Population  : " & Long_Long_Integer'Image(Nation.Population));	       	  
   	    --Text_Io.Put_Line(Decimal_Longitude_Type'Image(Nation.Longitude));
   	    --Text_Io.Put_Line(Decimal_Latitude_Type'Image(Nation.Latitude));
   	    --Text_Io.Put_Line("Converting decimal to Degree.Minutes.Seconds");	    
   	    GPS_Coordonates := To_GPS(Nation.longitude, Nation.latitude);
   	    Print(GPS_Coordonates);
   	    Map_Coordonates := To_Map_Coordonates(GPS_Coordonates);
   	    Print(Map_Coordonates);
	    Total_Population := Total_Population + Nation.Population;
	    Text_Io.New_Line;
	 end loop;
	 Text_Io.Put_Line("Total population = " & Long_Long_Integer'Image(Total_Population));
      end;
	 
      
      --  Text_Io.New_Line;
      --  Text_Io.Put_Line("----------------------------");
      --  Text_Io.Put_Line("-- Joshua initializaltion --");
      --  Text_Io.Put_Line("----------------------------");
      
      --  declare
      --  	 GPS_Coordonates : GPS_Coordonates_Type := To_GPS(2.1, -42.25);
      --  begin
      --  	 Joshua.GPS_Coordonates := GPS_Coordonates;
      --  	 Print(Joshua.GPS_Coordonates);
      --  	 Joshua.Population := All_Populations;	 
      --  end;
      
      
   end;
	       
      
   
   
end Test;
